# computes the first n powers of g modulo m
# returns a dictionary d with the property that
#    d[g^x] = x
# for x in {0,...,n}
#
# Using the dictionary, if h is a small power of g,
# then d[h] will give us log_g(h).
def first_n_powers (g,n,m):
	d = {}
	curr = 1
	for x in range(n+1):
		d[curr] = x
		curr = (curr * g) % m
	
	return d

# computes log_g(h) with a brute force
def naive_discrete_log (g,h,m):
	d = first_n_powers(g,m-1,m)
	if h in d:
		return d[h]
	else:
		raise ValueError("Discrete Log Undefined")

from math import sqrt

## your implementation here
def shanks_discrete_log (g,h,m):
	return 0

# for testing.  Compute log_2(3) modulo 83.
x = naive_discrete_log(2,3,83)
# If we raise 2 to the power x modulo 83, we should get back 3
val = pow(2,x,83) 
# here val should equal 3

# When your implementation shanks_discrete_log() is ready:
#p = 84298814015219
#x = shanks_discrete_log(2,3,p)
#print(str(x))

